package net.knarcraft.hungerarena;

import org.bukkit.Location;
import org.bukkit.World;

import java.util.List;
import java.util.Map;

public class Arena {

    private final int arenaId;
    private final World world;
    private final List<ArenaPlayer> arenaPlayers;
    private final ArenaState arenaState;
    private final boolean isJoinAble;
    private final boolean open;
    private final int countdownTimer;
    private int maxPlayers;
    private int gracePeriod;
    private final Map<Integer, Location> locations;

    public Arena(int arenaId, World world, List<ArenaPlayer> arenaPlayers, ArenaState arenaState, boolean isJoinAble,
                 boolean open, int countdownTimer, int maxPlayers, int gracePeriod,
                 Map<Integer, Location> locations) {
        this.arenaId = arenaId;
        this.world = world;
        this.arenaPlayers = arenaPlayers;
        this.arenaState = arenaState;
        this.isJoinAble = isJoinAble;
        this.open = open;
        this.countdownTimer = countdownTimer;
        this.maxPlayers = maxPlayers;
        this.gracePeriod = gracePeriod;
        this.locations = locations;
    }

    //TODO: Add arena name to make them easier to keep track of
    public void setMaxPlayers(int maxPlayers) {
        this.maxPlayers = maxPlayers;
    }

    public List<ArenaPlayer> getArenaPlayers() {
        return arenaPlayers;
    }

    public World getWorld() {
        return world;
    }

    public int getArenaId() {
        return arenaId;
    }

    public ArenaState getArenaState() {
        return arenaState;
    }

    public boolean isJoinAble() {
        return isJoinAble;
    }

    public boolean isOpen() {
        return open;
    }

    public int getCountdownTimer() {
        return countdownTimer;
    }

    public int getMaxPlayers() {
        return maxPlayers;
    }

    public int getGracePeriod() {
        return gracePeriod;
    }

    public Map<Integer, Location> getLocations() {
        return locations;
    }

    public void setGracePeriod(int gracePeriod) {
        this.gracePeriod = gracePeriod;
    }

}
